ForwardingTable
Date: 2016-05-24

com.google.common.collect

## Class ForwardingTable<R,C,V>

- java.lang.Object
- - com.google.common.collect.ForwardingObject
  - - com.google.common.collect.ForwardingTable<R,C,V>

- All Implemented Interfaces:
    Table<R,C,V>

      @GwtCompatible
      public abstract class ForwardingTable<R,C,V>
      extends ForwardingObject
      implements Table<R,C,V>

  A table which forwards all its method calls to another table. Subclasses should override one or more methods to modify the behavior of the backing map as desired per the decorator pattern.
  Since:
    7.0

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.google.common.collect.Table

      `Table.Cell<R,C,V>`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ForwardingTable()` Constructor for use by subclasses.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.Set<Table.Cell<R,C,V>>` | `cellSet()` Returns a set of all row key / column key / value triplets.
    `void` | `clear()` Removes all mappings from the table.
    `java.util.Map<R,V>` | `column(C columnKey)` Returns a view of all mappings that have the given column key.
    `java.util.Set<C>` | `columnKeySet()` Returns a set of column keys that have one or more values in the table.
    `java.util.Map<C,java.util.Map<R,V>>` | `columnMap()` Returns a view that associates each column key with the corresponding map from row keys to values.
    `boolean` | `contains(java.lang.Object rowKey, java.lang.Object columnKey)` Returns `true` if the table contains a mapping with the specified row and column keys.
    `boolean` | `containsColumn(java.lang.Object columnKey)` Returns `true` if the table contains a mapping with the specified column.
    `boolean` | `containsRow(java.lang.Object rowKey)` Returns `true` if the table contains a mapping with the specified row key.
    `boolean` | `containsValue(java.lang.Object value)` Returns `true` if the table contains a mapping with the specified value.
    `protected abstract Table<R,C,V>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.
    `boolean` | `equals(java.lang.Object obj)` Compares the specified object with this table for equality.
    `V` | `get(java.lang.Object rowKey, java.lang.Object columnKey)` Returns the value corresponding to the given row and column keys, or `null` if no such mapping exists.
    `int` | `hashCode()` Returns the hash code for this table.
    `boolean` | `isEmpty()` Returns `true` if the table contains no mappings.
    `V` | `put(R rowKey, C columnKey, V value)` Associates the specified value with the specified keys.
    `void` | `putAll(Table<? extends R,? extends C,? extends V> table)` Copies all mappings from the specified table to this table.
    `V` | `remove(java.lang.Object rowKey, java.lang.Object columnKey)` Removes the mapping, if any, associated with the given keys.
    `java.util.Map<C,V>` | `row(R rowKey)` Returns a view of all mappings that have the given row key.
    `java.util.Set<R>` | `rowKeySet()` Returns a set of row keys that have one or more values in the table.
    `java.util.Map<R,java.util.Map<C,V>>` | `rowMap()` Returns a view that associates each row key with the corresponding map from column keys to values.
    `int` | `size()` Returns the number of row key / column key / value mappings in the table.
    `java.util.Collection<V>` | `values()` Returns a collection of all values, which may contain duplicates.

    - ### Methods inherited from class com.google.common.collect.ForwardingObject

      `toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ForwardingTable

          protected ForwardingTable()

      Constructor for use by subclasses.

  - ### Method Detail

    - #### delegate

          protected abstract Table<R,C,V> delegate()

      Description copied from class: `ForwardingObject`
      Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `ForwardingSet.delegate()`. Concrete subclasses override this method to supply the instance being decorated.
      Specified by:
        `delegate` in class `ForwardingObject`

    - #### cellSet

          public java.util.Set<Table.Cell<R,C,V>> cellSet()

      Description copied from interface: `Table`
      Returns a set of all row key / column key / value triplets. Changes to the returned set will update the underlying table, and vice versa. The cell set does not support the `add` or `addAll` methods.
      Specified by:
        `cellSet` in interface `Table<R,C,V>`
      Returns:
        set of table cells consisting of row key / column key / value triplets

    - #### clear

          public void clear()

      Description copied from interface: `Table`
      Removes all mappings from the table.
      Specified by:
        `clear` in interface `Table<R,C,V>`

    - #### column

          public java.util.Map<R,V> column(C columnKey)

      Description copied from interface: `Table`
      Returns a view of all mappings that have the given column key. For each row key / column key / value mapping in the table with that column key, the returned map associates the row key with the value. If no mappings in the table have the provided column key, an empty map is returned.

      Changes to the returned map will update the underlying table, and vice versa.

      Specified by:
        `column` in interface `Table<R,C,V>`
      Parameters:
        `columnKey` - key of column to search for in the table
      Returns:
        the corresponding map from row keys to values

    - #### columnKeySet

          public java.util.Set<C> columnKeySet()

      Description copied from interface: `Table`
      Returns a set of column keys that have one or more values in the table. Changes to the set will update the underlying table, and vice versa.
      Specified by:
        `columnKeySet` in interface `Table<R,C,V>`
      Returns:
        set of column keys

    - #### columnMap

          public java.util.Map<C,java.util.Map<R,V>> columnMap()

      Description copied from interface: `Table`
      Returns a view that associates each column key with the corresponding map from row keys to values. Changes to the returned map will update this table. The returned map does not support `put()` or `putAll()`, or `setValue()` on its entries.

      In contrast, the maps returned by `columnMap().get()` have the same behavior as those returned by `Table.column(C)`. Those maps may support `setValue()`, `put()`, and `putAll()`.

      Specified by:
        `columnMap` in interface `Table<R,C,V>`
      Returns:
        a map view from each column key to a secondary map from row keys to values

    - #### contains

          public boolean contains(java.lang.Object rowKey,
                         java.lang.Object columnKey)

      Description copied from interface: `Table`
      Returns `true` if the table contains a mapping with the specified row and column keys.
      Specified by:
        `contains` in interface `Table<R,C,V>`
      Parameters:
        `rowKey` - key of row to search for
        `columnKey` - key of column to search for

    - #### containsColumn

          public boolean containsColumn(java.lang.Object columnKey)

      Description copied from interface: `Table`
      Returns `true` if the table contains a mapping with the specified column.
      Specified by:
        `containsColumn` in interface `Table<R,C,V>`
      Parameters:
        `columnKey` - key of column to search for

    - #### containsRow

          public boolean containsRow(java.lang.Object rowKey)

      Description copied from interface: `Table`
      Returns `true` if the table contains a mapping with the specified row key.
      Specified by:
        `containsRow` in interface `Table<R,C,V>`
      Parameters:
        `rowKey` - key of row to search for

    - #### containsValue

          public boolean containsValue(java.lang.Object value)

      Description copied from interface: `Table`
      Returns `true` if the table contains a mapping with the specified value.
      Specified by:
        `containsValue` in interface `Table<R,C,V>`
      Parameters:
        `value` - value to search for

    - #### get

          public V get(java.lang.Object rowKey,
              java.lang.Object columnKey)

      Description copied from interface: `Table`
      Returns the value corresponding to the given row and column keys, or `null` if no such mapping exists.
      Specified by:
        `get` in interface `Table<R,C,V>`
      Parameters:
        `rowKey` - key of row to search for
        `columnKey` - key of column to search for

    - #### isEmpty

          public boolean isEmpty()

      Description copied from interface: `Table`
      Returns `true` if the table contains no mappings.
      Specified by:
        `isEmpty` in interface `Table<R,C,V>`

    - #### put

          public V put(R rowKey,
              C columnKey,
              V value)

      Description copied from interface: `Table`
      Associates the specified value with the specified keys. If the table already contained a mapping for those keys, the old value is replaced with the specified value.
      Specified by:
        `put` in interface `Table<R,C,V>`
      Parameters:
        `rowKey` - row key that the value should be associated with
        `columnKey` - column key that the value should be associated with
        `value` - value to be associated with the specified keys
      Returns:
        the value previously associated with the keys, or `null` if no mapping existed for the keys

    - #### putAll

          public void putAll(Table<? extends R,? extends C,? extends V> table)

      Description copied from interface: `Table`
      Copies all mappings from the specified table to this table. The effect is equivalent to calling `Table.put(R, C, V)` with each row key / column key / value mapping in `table`.
      Specified by:
        `putAll` in interface `Table<R,C,V>`
      Parameters:
        `table` - the table to add to this table

    - #### remove

          public V remove(java.lang.Object rowKey,
                 java.lang.Object columnKey)

      Description copied from interface: `Table`
      Removes the mapping, if any, associated with the given keys.
      Specified by:
        `remove` in interface `Table<R,C,V>`
      Parameters:
        `rowKey` - row key of mapping to be removed
        `columnKey` - column key of mapping to be removed
      Returns:
        the value previously associated with the keys, or `null` if no such value existed

    - #### row

          public java.util.Map<C,V> row(R rowKey)

      Description copied from interface: `Table`
      Returns a view of all mappings that have the given row key. For each row key / column key / value mapping in the table with that row key, the returned map associates the column key with the value. If no mappings in the table have the provided row key, an empty map is returned.

      Changes to the returned map will update the underlying table, and vice versa.

      Specified by:
        `row` in interface `Table<R,C,V>`
      Parameters:
        `rowKey` - key of row to search for in the table
      Returns:
        the corresponding map from column keys to values

    - #### rowKeySet

          public java.util.Set<R> rowKeySet()

      Description copied from interface: `Table`
      Returns a set of row keys that have one or more values in the table. Changes to the set will update the underlying table, and vice versa.
      Specified by:
        `rowKeySet` in interface `Table<R,C,V>`
      Returns:
        set of row keys

    - #### rowMap

          public java.util.Map<R,java.util.Map<C,V>> rowMap()

      Description copied from interface: `Table`
      Returns a view that associates each row key with the corresponding map from column keys to values. Changes to the returned map will update this table. The returned map does not support `put()` or `putAll()`, or `setValue()` on its entries.

      In contrast, the maps returned by `rowMap().get()` have the same behavior as those returned by `Table.row(R)`. Those maps may support `setValue()`, `put()`, and `putAll()`.

      Specified by:
        `rowMap` in interface `Table<R,C,V>`
      Returns:
        a map view from each row key to a secondary map from column keys to values

    - #### size

          public int size()

      Description copied from interface: `Table`
      Returns the number of row key / column key / value mappings in the table.
      Specified by:
        `size` in interface `Table<R,C,V>`

    - #### values

          public java.util.Collection<V> values()

      Description copied from interface: `Table`
      Returns a collection of all values, which may contain duplicates. Changes to the returned collection will update the underlying table, and vice versa.
      Specified by:
        `values` in interface `Table<R,C,V>`
      Returns:
        collection of values

    - #### equals

          public boolean equals(java.lang.Object obj)

      Description copied from interface: `Table`
      Compares the specified object with this table for equality. Two tables are equal when their cell views, as returned by `Table.cellSet()`, are equal.
      Specified by:
        `equals` in interface `Table<R,C,V>`
      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Description copied from interface: `Table`
      Returns the hash code for this table. The hash code of a table is defined as the hash code of its cell view, as returned by `Table.cellSet()`.
      Specified by:
        `hashCode` in interface `Table<R,C,V>`
      Overrides:
        `hashCode` in class `java.lang.Object`